#!/usr/bin/bash
#
#

#
#$Header: /home2/reps/cvs/proj/ctys/ctys-rt/src/conf/ctys/vnc/vnc.conf-CYGWIN.sh,v 1.3 2011/12/05 15:57:42 acue Exp $
#


########################################################################
#
#PROJECT:      Unified Sessions Manager
#AUTHOR:       Arno-Can Uestuensoez - unifiedsessionsmanager@protonmail.com
#MAINTAINER:   Arno-Can Uestuensoez - unifiedsessionsmanager@protonmail.com
#SHORT:        ctys
#CALLFULLNAME: Commutate To Your Session
#LICENCE:      GPL3
#VERSION:      01_11_023
#
########################################################################
#
# Copyright (C) 2011 Arno-Can Uestuensoez
#
########################################################################

########################################################################
#
#     Copyright (C) 2011 Arno-Can Uestuensoez
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
########################################################################

printDBG $S_CONF  ${D_FRAME} $LINENO $BASH_SOURCE "LOAD-CONFIG:${BASH_SOURCE}"

#protect multiple inclusion
if [ -z "$__VNC_INCLUDED__" ];then
__VNC_INCLUDED__=0

################################################################
#    Default definitions - User-Customizable  from shell       #
################################################################

export VNC_BASEPORT=${VNC_BASEPORT:-5900}
export VNCACCESSPORT;
export VNCACCESSDISPLAY;

#avoids race conditions "lazy release vs. hungry allocation"
VNCPORTSEED=10;

#make all specific, due to frequent minimal deviation, BUT A DEVIATION, for what ever reason???!!!
#
#ffs.:"copyrect"
#keep "hextile" for being generic for VMware-WS6 too(see pg. 183).
#
case ${MYDIST} in
    CYGWIN*)
	[ -z "$VNCVEXE" ]&&VNCVEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncviewer /usr/bin`
	[ -z "$VNCVEXE" ]&&VNCVEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncviewer.exe /cygdrive/c/RealVNC/VNC4`
	[ -z "$VNCVEXE" ]&&VNCVEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncviewer.exe /cygdrive/c/TightVNC`
	[ -z "$VNCVEXE" ]&&VNCVEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncviewer.exe /cygdrive/c/vnc`

	[ -z "$VNCSEXE" ]&&VNCSEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncserver /usr/bin`
	[ -z "$VNCSEXE" ]&&VNCSEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT winvnc4.exe /cygdrive/c/RealVNC/VNC4`
	[ -z "$VNCSEXE" ]&&VNCSEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT tvnserver.exe /cygdrive/c/TightVNC`
	[ -z "$VNCSEXE" ]&&VNCSEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncserver.exe /cygdrive/c/vnc`

	[ -z "$VNCPEXE" ]&&VNCPEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncpasswd /usr/bin`
	[ -z "$VNCPEXE" ]&&VNCPEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncpasswd.exe /cygdrive/c/RealVNC/VNC4`
	[ -z "$VNCPEXE" ]&&VNCPEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncpasswd.exe /cygdrive/c/TightVNC`
	[ -z "$VNCPEXE" ]&&VNCPEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncpasswd.exe /cygdrive/c/vnc`

        #vncviewer - passed through by wrapper
	VNCVIEWER_NATIVE=${VNCVIEWER_NATIVE:-$VNCVEXE}
	[ -z "${VNCVIEWER_OPT_RealVNC4}" ]&&VNCVIEWER_OPT_RealVNC4=" PreferredEncoding=Hextile FullColour AutoSelect=0 Shared=1 "
	[ -z "${VNCVIEWER_OPT_RealVNC}" ]&&VNCVIEWER_OPT_RealVNC=" PreferredEncoding=Hextile FullColour AutoSelect=0 Shared=1 "
	[ -z "${VNCVIEWER_OPT_TigerVNC}" ]&&VNCVIEWER_OPT_TigerVNC=" PreferredEncoding=Hextile FullColour AutoSelect=0 Shared=1 "
	[ -z "${VNCVIEWER_OPT_TightVNC}" ]&&VNCVIEWER_OPT_TightVNC="  "
	[ -z "${VNCVIEWER_OPT_GENERIC}" ]&&VNCVIEWER_OPT_GENERIC=""

        #vncserver - passed through by wrapper
	VNCSERVER_NATIVE=${VNCSERVER_NATIVE:-$VNCSEXE}
	[ -z "${VNCSERVER_OPT_RealVNC4}" ]&&VNCSERVER_OPT_RealVNC4="   -depth 24 -geometry 1268x994 -localhost -nolisten tcp -nohttpd "
	[ -z "${VNCSERVER_OPT_RealVNC}" ]&&VNCSERVER_OPT_RealVNC="    -depth 24 -geometry 1268x994 -localhost -nolisten tcp -nohttpd "
	[ -z "${VNCSERVER_OPT_TigerVNC}" ]&&VNCSERVER_OPT_TigerVNC="   -depth 24 -geometry 1268x994 -localhost -nolisten tcp "
	[ -z "${VNCSERVER_OPT_TightVNC}" ]&&VNCSERVER_OPT_TightVNC="   -depth 24 -geometry 1268x994 -localhost -nolisten tcp "
	[ -z "${VNCSERVER_OPT_GENERIC}" ]&&VNCSERVER_OPT_GENERIC="    -depth 24 -geometry 1268x994 -localhost -nolisten tcp "
	;;
    *)
	[ -z "$VNCVEXE" ]&&VNCVEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncviewer /usr/bin`
	[ -z "$VNCSEXE" ]&&VNCSEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncserver /usr/bin`
	[ -z "$VNCPEXE" ]&&VNCPEXE=`getPathName $LINENO $BASH_SOURCE WARNINGEXT vncpasswd /usr/bin`

        #vncviewer - passed through by wrapper
	VNCVIEWER_NATIVE=${VNCVIEWER_NATIVE:-$VNCVEXE}
	[ -z "${VNCVIEWER_OPT_RealVNC4}" ]&&VNCVIEWER_OPT_RealVNC4="    -PreferredEncoding hextile  -FullColour -AutoSelect=0 -Shared=1 "
	[ -z "${VNCVIEWER_OPT_RealVNC}" ]&&VNCVIEWER_OPT_RealVNC="     -PreferredEncoding hextile  -FullColour -AutoSelect=0 -Shared=1 "
	[ -z "${VNCVIEWER_OPT_TigerVNC}" ]&&VNCVIEWER_OPT_TigerVNC="    -PreferredEncoding hextile  -FullColour -AutoSelect=0 -Shared=1 "
	[ -z "${VNCVIEWER_OPT_TightVNC}" ]&&VNCVIEWER_OPT_TightVNC="    -encodings         hextile  -truecolour  -shared "
	[ -z "${VNCVIEWER_OPT_GENERIC}" ]&&VNCVIEWER_OPT_GENERIC=""

        #vncserver - passed through by wrapper
	VNCSERVER_NATIVE=${VNCSERVER_NATIVE:-$VNCSEXE}
	[ -z "${VNCSERVER_OPT_RealVNC4}" ]&&VNCSERVER_OPT_RealVNC4="    -depth 24 -geometry 1268x994 -localhost -nolisten tcp -nohttpd "
	[ -z "${VNCSERVER_OPT_RealVNC}" ]&&VNCSERVER_OPT_RealVNC="     -depth 24 -geometry 1268x994 -localhost -nolisten tcp -nohttpd "
	[ -z "${VNCSERVER_OPT_TigerVNC}" ]&&VNCSERVER_OPT_TigerVNC="   -depth 24 -geometry 1268x994 -localhost -nolisten tcp "
	[ -z "${VNCSERVER_OPT_TightVNC}" ]&&VNCSERVER_OPT_TightVNC="    -depth 24 -geometry 1268x994 -localhost -nolisten tcp "
	[ -z "${VNCSERVER_OPT_GENERIC}" ]&&VNCSERVER_OPT_GENERIC="     -depth 24 -geometry 1268x994 -localhost -nolisten tcp "
	;;
esac



#
#For products with combined start the server-wait+client-wait is performed.
#
#Timeout after execution of client/server.
VNC_INIT_WAITC=${VNC_INIT_WAITC:-1}
VNC_INIT_WAITS=${VNC_INIT_WAITS:-2}

#protect multiple inclusion
fi
